Index: TXM/trunk/org.txm.core/src/java/org/txm/importer/ImportPreferencesManager.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/importer/ImportPreferencesManager.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/importer/ImportPreferencesManager.java	(revision 3628)
@@ -54,7 +54,7 @@
 		if ("0.8.0".equals(version)) {
 			loadFrom080();
 		}
-		else if ("0.8.2".equals(version)) {
+		else if ("0.8.3".equals(version)) {
 			genericLoad();
 		}
 		else {
@@ -82,11 +82,11 @@
 			Preferences section = sectionList.node(sectionNames[i]);
 			String name = section.name();
 			if (name == null || name.length() == 0) {
-				Log.warning("Load import 0.8.2 parameters: section with no name");
+				Log.warning("Load import 0.8.3 parameters: section with no name");
 				continue;
 			}
 			if (sections.containsKey(name)) {
-				Log.warning("Load import 0.8.2 parameters: duplicated section with name:" + name);
+				Log.warning("Load import 0.8.3 parameters: duplicated section with name:" + name);
 				continue;
 			}
 			
@@ -96,7 +96,7 @@
 				String parameter = section.get(name2, "");
 				
 				if (sectionParameters.containsKey(name2)) {
-					Log.warning("Load import 0.8.2 parameters: duplicated parameter with name:" + name2 + " in section: " + name);
+					Log.warning("Load import 0.8.3 parameters: duplicated parameter with name:" + name2 + " in section: " + name);
 					continue;
 				}
 				
@@ -110,7 +110,7 @@
 		if ("0.8.0".equals(version)) {
 			saveFrom080();
 		}
-		else if ("0.8.2".equals(version)) {
+		else if ("0.8.3".equals(version)) {
 			genericSave();
 		}
 		else {
Index: TXM/trunk/org.txm.core/src/java/org/txm/importer/ApplyXsl2.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/importer/ApplyXsl2.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/importer/ApplyXsl2.java	(revision 3628)
@@ -72,7 +72,6 @@
 import org.txm.utils.io.FileCopy;
 import org.txm.utils.io.IOUtils;
 import org.txm.utils.logger.Log;
-import org.txm.utils.saxon.SaxonNodeSet;
 
 import net.sf.saxon.TransformerFactoryImpl;
 
@@ -147,7 +146,7 @@
 		
 		tFactory = new net.sf.saxon.TransformerFactoryImpl();
 		// Log.info("new tFactory: "+tFactory);
-		tFactory.getConfiguration().registerExtensionFunction(new SaxonNodeSet());
+		//tFactory.getConfiguration().registerExtensionFunction(new SaxonNodeSet());
 		Log.fine(NLS.bind("ApplyXsl2 with the {0} stylesheet.", xsltfile));
 		reload();
 		// Log.info("new transformer: "+transformer);
Index: TXM/trunk/org.txm.core/src/java/org/txm/importer/ImportFileManager.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/importer/ImportFileManager.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/importer/ImportFileManager.java	(revision 3628)
@@ -59,7 +59,7 @@
 			if ("0.7.9".equals(version)) {
 				loadFrom079();
 			}
-			else if ("0.8.2".equals(version)) {
+			else if ("0.8.3".equals(version)) {
 				genericLoad();
 			}
 			else {
@@ -84,11 +84,11 @@
 			Element section = (Element) sectionList.item(i);
 			String name = section.getAttribute("name");
 			if (name == null || name.length() == 0) {
-				Log.warning("Load import 0.8.2 parameters: section with no name");
+				Log.warning("Load import 0.8.3 parameters: section with no name");
 				continue;
 			}
 			if (sections.containsKey(name)) {
-				Log.warning("Load import 0.8.2 parameters: duplicated section with name:" + name);
+				Log.warning("Load import 0.8.3 parameters: duplicated section with name:" + name);
 				continue;
 			}
 			
@@ -99,11 +99,11 @@
 				Element parameter = (Element) parameterList.item(j);
 				String name2 = parameter.getAttribute("name");
 				if (name2 == null || name2.length() == 0) {
-					Log.warning("Load import 0.8.2 parameters: parameter with no name in section: " + name);
+					Log.warning("Load import 0.8.3 parameters: parameter with no name in section: " + name);
 					continue;
 				}
 				if (sectionParameters.containsKey(name2)) {
-					Log.warning("Load import 0.8.2 parameters: duplicated parameter with name:" + name2 + " in section: " + name);
+					Log.warning("Load import 0.8.3 parameters: duplicated parameter with name:" + name2 + " in section: " + name);
 					continue;
 				}
 				
Index: TXM/trunk/org.txm.core/.classpath
===================================================================
--- TXM/trunk/org.txm.core/.classpath	(revision 3627)
+++ TXM/trunk/org.txm.core/.classpath	(revision 3628)
@@ -1,34 +1,41 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <classpath>
-	<classpathentry exported="true" kind="lib" path="lib/jsoup-1.11.3.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/ant-1.7.1.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/ant-launcher.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/ant.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/antlr-2.7.7.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/asm-analysis-2.2.3.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/asm-tree-2.2.3.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/concurrent-1.3.4.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/dom4j-1.6.1.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/forms-1.0.7.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/jline-0.9.94.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/junit-4.5.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/jvectClipboard-1.2.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/liquidlnf.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/log4j-1.2.12.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/looks-2.0.1.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/macSpecific.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/quaqua.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/rtfCleaner.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/swing-layout-1.0.3.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/juniversalchardet-1.0.3.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/textcat-1.0.1.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/json-20090211.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/ridl-3.2.1.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/unoil-3.2.1.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/sqlite-jdbc-3.8.11.2.jar"/>
-	<classpathentry exported="true" kind="lib" path="lib/postgresql-9.4.1207.jre6.jar"/>
-	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
-	<classpathentry exported="true" kind="con" path="org.eclipse.pde.core.requiredPlugins">
+	<classpathentry kind="src" path="src/java"/>
+	<classpathentry kind="src" path="test"/>
+	<classpathentry kind="src" path="res"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER">
+		<accessrules>
+			<accessrule kind="accessible" pattern="**"/>
+		</accessrules>
+	</classpathentry>
+	<classpathentry kind="lib" path="lib/jsoup-1.11.3.jar"/>
+	<classpathentry kind="lib" path="lib/ant-1.7.1.jar"/>
+	<classpathentry kind="lib" path="lib/ant-launcher.jar"/>
+	<classpathentry kind="lib" path="lib/ant.jar"/>
+	<classpathentry kind="lib" path="lib/antlr-2.7.7.jar"/>
+	<classpathentry kind="lib" path="lib/asm-analysis-2.2.3.jar"/>
+	<classpathentry kind="lib" path="lib/asm-tree-2.2.3.jar"/>
+	<classpathentry kind="lib" path="lib/concurrent-1.3.4.jar"/>
+	<classpathentry kind="lib" path="lib/dom4j-1.6.1.jar"/>
+	<classpathentry kind="lib" path="lib/forms-1.0.7.jar"/>
+	<classpathentry kind="lib" path="lib/jline-0.9.94.jar"/>
+	<classpathentry kind="lib" path="lib/junit-4.5.jar"/>
+	<classpathentry kind="lib" path="lib/jvectClipboard-1.2.jar"/>
+	<classpathentry kind="lib" path="lib/liquidlnf.jar"/>
+	<classpathentry kind="lib" path="lib/log4j-1.2.12.jar"/>
+	<classpathentry kind="lib" path="lib/looks-2.0.1.jar"/>
+	<classpathentry kind="lib" path="lib/macSpecific.jar"/>
+	<classpathentry kind="lib" path="lib/quaqua.jar"/>
+	<classpathentry kind="lib" path="lib/rtfCleaner.jar"/>
+	<classpathentry kind="lib" path="lib/swing-layout-1.0.3.jar"/>
+	<classpathentry kind="lib" path="lib/juniversalchardet-1.0.3.jar"/>
+	<classpathentry kind="lib" path="lib/textcat-1.0.1.jar"/>
+	<classpathentry kind="lib" path="lib/json-20090211.jar"/>
+	<classpathentry kind="lib" path="lib/ridl-3.2.1.jar"/>
+	<classpathentry kind="lib" path="lib/unoil-3.2.1.jar"/>
+	<classpathentry kind="lib" path="lib/sqlite-jdbc-3.8.11.2.jar"/>
+	<classpathentry kind="lib" path="lib/postgresql-9.4.1207.jre6.jar"/>
+	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins">
 		<attributes>
 			<attribute name="org.eclipse.jdt.launching.CLASSPATH_ATTR_LIBRARY_PATH_ENTRY" value="org.txm.toolbox/native"/>
 		</attributes>
@@ -36,10 +43,7 @@
 			<accessrule kind="accessible" pattern="**"/>
 		</accessrules>
 	</classpathentry>
-	<classpathentry kind="src" path="src/java"/>
-	<classpathentry kind="src" path="test"/>
-	<classpathentry kind="src" path="res"/>
-	<classpathentry exported="true" kind="con" path="GROOVY_DSL_SUPPORT"/>
-	<classpathentry exported="true" kind="lib" path="lib/jodconverter-core-3.1-beta.jar"/>
+	<classpathentry kind="con" path="GROOVY_DSL_SUPPORT"/>
+	<classpathentry kind="lib" path="lib/jodconverter-core-3.1-beta.jar"/>
 	<classpathentry kind="output" path="bin"/>
 </classpath>
Index: TXM/trunk/org.txm.core/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.core/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.core/META-INF/MANIFEST.MF	(revision 3628)
@@ -437,7 +437,7 @@
  src.main.assembly,
  target
 Bundle-SymbolicName: org.txm.core;singleton:=true
-Bundle-Version: 0.8.2.qualifier
+Bundle-Version: 0.8.3.qualifier
 Bundle-Name: TXM Core Toolbox
 Bundle-ClassPath: .,
  lib/ant-1.7.1.jar,
@@ -446,7 +446,6 @@
  lib/antlr-2.7.7.jar,
  lib/asm-analysis-2.2.3.jar,
  lib/asm-tree-2.2.3.jar,
- lib/colt-1.2.0.jar,
  lib/concurrent-1.3.4.jar,
  lib/dom4j-1.6.1.jar,
  lib/forms-1.0.7.jar,
@@ -458,14 +457,10 @@
  lib/looks-2.0.1.jar,
  lib/macSpecific.jar,
  lib/quaqua.jar,
- lib/REngine.jar,
- lib/RserveEngine.jar,
  lib/rtfCleaner.jar,
  lib/swing-layout-1.0.3.jar,
  lib/juniversalchardet-1.0.3.jar,
  lib/textcat-1.0.1.jar,
- lib/saxon9he.jar,
- lib/jtidy-r938.jar,
  lib/json-20090211.jar,
  lib/juh-3.2.1.jar,
  lib/jurt-3.2.1.jar,
@@ -475,15 +470,15 @@
  lib/postgresql-9.4.1207.jre6.jar,
  lib/jodconverter-core-3.1-beta.jar,
  lib/jsoup-1.11.3.jar
-Require-Bundle: org.txm.utils.core;bundle-version="1.0.0";visibility:=reexport,
- org.txm.libs.groovy-all;bundle-version="1.0.0";visibility:=reexport,
- org.eclipse.core.runtime;bundle-version="3.10.0";visibility:=reexport,
+Require-Bundle: org.eclipse.core.runtime;bundle-version="3.10.0";visibility:=reexport,
  org.eclipse.osgi.util;bundle-version="3.2.0";visibility:=reexport,
  org.eclipse.core.net;visibility:=reexport,
  org.eclipse.osgi;visibility:=reexport,
  org.eclipse.ui.workbench;visibility:=reexport,
  org.eclipse.core.commands;visibility:=reexport,
  org.eclipse.core.resources;visibility:=reexport,
+ org.txm.utils.core;bundle-version="1.0.0";visibility:=reexport,
+ org.txm.libs.groovy-all;bundle-version="1.0.0";visibility:=reexport,
  org.txm.libs.office;bundle-version="0.0.0";visibility:=reexport,
  org.txm.libs.msoffice;bundle-version="0.0.0";visibility:=reexport,
  org.txm.libs.hsqldb;bundle-version="1.0.0";visibility:=reexport,
@@ -491,7 +486,8 @@
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
 Bundle-Activator: org.txm.core.Activator
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: Textometrie.org
 Automatic-Module-Name: org.txm.core
+Eclipse-BundleShape: dir
 
Index: TXM/trunk/org.txm.core/.settings/org.eclipse.jdt.groovy.core.prefs
===================================================================
--- TXM/trunk/org.txm.core/.settings/org.eclipse.jdt.groovy.core.prefs	(revision 3627)
+++ TXM/trunk/org.txm.core/.settings/org.eclipse.jdt.groovy.core.prefs	(revision 3628)
@@ -1,3 +1,3 @@
 eclipse.preferences.version=1
-groovy.compiler.level=30
+groovy.compiler.level=40
 groovy.script.filters=scripts/**/*.groovy,y,src/main/resources/**/*.groovy,y,src/test/resources/**/*.groovy,y
Index: TXM/trunk/org.txm.internalview.core/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.internalview.core/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.internalview.core/META-INF/MANIFEST.MF	(revision 3628)
@@ -7,7 +7,7 @@
 Require-Bundle: org.txm.searchengine.cqp.core;visibility:=reexport
 Bundle-ActivationPolicy: lazy
 Bundle-ManifestVersion: 2
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: Textometrie.org
 Automatic-Module-Name: org.txm.internalview.core
 

Index: TXM/trunk/org.txm.texts.core/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.texts.core/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.texts.core/META-INF/MANIFEST.MF	(revision 3628)
@@ -4,8 +4,8 @@
 Bundle-SymbolicName: org.txm.texts.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Automatic-Module-Name: org.txm.texts.core
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
-Require-Bundle: org.txm.core;bundle-version="0.8.2";visibility:=reexport,
+Bundle-RequiredExecutionEnvironment: JavaSE-16
+Require-Bundle: org.txm.core;bundle-version="0.8.3";visibility:=reexport,
  org.txm.searchengine.core;bundle-version="1.0.0";visibility:=reexport,
  org.txm.utils.core;visibility:=reexport,
  org.txm.searchengine.cqp.core;visibility:=reexport
Index: TXM/trunk/org.txm.texts.core/src/org/txm/texts/core/TextsView.java
===================================================================
--- TXM/trunk/org.txm.texts.core/src/org/txm/texts/core/TextsView.java	(revision 3627)
+++ TXM/trunk/org.txm.texts.core/src/org/txm/texts/core/TextsView.java	(revision 3628)
@@ -13,52 +13,55 @@
 import org.txm.core.results.TXMResult;
 import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.QueryResult;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
 import org.txm.utils.TXMProgressMonitor;
 import org.txm.utils.logger.Log;
 
 public class TextsView extends TXMResult {
-	
+
 	@Parameter(key = "columns")
 	ArrayList<StructuralUnitProperty> pColumns;
-	
-//	@Parameter(key = "positiveFilters")
-//	ArrayList<String> positiveFilters;
-	
+
+	//	@Parameter(key = "positiveFilters")
+	//	ArrayList<String> positiveFilters;
+
 	@Parameter(key = "negativeFilters")
 	String negativeFilters;
-	
+
 	private LinkedHashMap<String, ArrayList<String>> result;
-	
+
 	public CQPCorpus getCorpus() {
 		return (CQPCorpus)parent;
 	}
-	
+
 	public TextsView(CQPCorpus corpus) {
-		
+
 		super(corpus);
 	}
-	
+
 	public TextsView(String parametersNodePath) {
-		
+
 		super(parametersNodePath);
 	}
-	
-	
-	
+
+
+
 	@Override
 	public boolean saveParameters() throws Exception {
-		
+
 		this.saveParameter("columns", StringUtils.join(pColumns, "\t"));
-//		this.saveParameter("positiveFilters", StringUtils.join(positiveFilters, "\t"));
+		//		this.saveParameter("positiveFilters", StringUtils.join(positiveFilters, "\t"));
 		this.saveParameter("negativeFilters", negativeFilters);
 		return true;
 	}
-	
+
 	@Override
 	public boolean loadParameters() throws Exception {
-		
+
 		String v = this.getStringParameterValue("columns").toString();
 		if ("*".equals(v)) {
 			;
@@ -70,31 +73,31 @@
 				}
 			}
 		} else {
-			this.pColumns = new ArrayList(Property.stringToProperties(getCorpus(), v));
+			this.pColumns = new ArrayList(StructuralUnitProperty.stringToProperties(getCorpus(), v));
 		}
-		
+
 		v = this.getStringParameterValue("negativeFilters").toString();
 		if (v.contains("=")) {
 			this.negativeFilters = v;
 		} else {
 			this.negativeFilters = "";
 		}
-		
-//		v = this.getStringParameterValue("positiveFilters").toString();
-//		if (v.contains("=")) {
-//			this.positiveFilters = new ArrayList<>(Arrays.asList(v.split("\t")));
-//		} else {
-//			this.positiveFilters = new ArrayList<>();
-//		}
-		
+
+		//		v = this.getStringParameterValue("positiveFilters").toString();
+		//		if (v.contains("=")) {
+		//			this.positiveFilters = new ArrayList<>(Arrays.asList(v.split("\t")));
+		//		} else {
+		//			this.positiveFilters = new ArrayList<>();
+		//		}
+
 		return pColumns != null;
 	}
-	
+
 	@Override
 	public boolean setParameters(TXMParameters parameters) throws Exception {
-		
+
 		if (parameters.get("columns") != null) {
-			
+
 			Object o = parameters.get("columns");
 			if (o instanceof List) {
 				pColumns = new ArrayList((List)o);
@@ -110,79 +113,99 @@
 		}
 		return false;
 	}
-	
+
 	@Override
 	public String getName() {
-		
+
 		return "Texts ("+pColumns+")";
 	}
-	
+
 	@Override
 	public String getSimpleName() {
-		
+
 		return "Texts";
 	}
-	
+
 	@Override
 	public String getDetails() {
-		
+
 		return getName();
 	}
-	
+
 	@Override
 	public void clean() {
-		
+
 	}
-	
+
 	@Override
 	public boolean canCompute() throws Exception {
-		
+
 		return pColumns != null;
 	}
-	
+
 	@Override
 	protected boolean _compute(TXMProgressMonitor monitor) throws Exception {
-		
+
 		result = new LinkedHashMap<String, ArrayList<String>>();
-		
+
 		// preset arrays
 		String[] texts = getCorpus().getCorpusTextIdsList();
 		for (String t : texts) {
-			
+
 			ArrayList<String> values = new ArrayList<String>();
 			result.put(t, values);
-			
+
 			if (getCorpus().getProject().getText(t) == null) {
 				Log.warning(NLS.bind("The {0} Corpus has no text named ''{1}''.", getCorpus(), t));
 				return false;
 			}
 		}
+
+		// optimization: get values property per property then set the Text property value arrays
 		
-		// optimization: get values property per property then set the Text property value arrays
-		int positions [] = new int[texts.length];
-		for (int i = 0 ; i < texts.length ; i++) {
-			positions[i] = i;
-		}
-		for (int icol = 0 ; icol < pColumns.size() ; icol++) {
-			StructuralUnitProperty col = pColumns.get(icol);
+		if (getCorpus() instanceof MainCorpus) {
+			int[] idx = new int[texts.length];
+			for (int i = 0 ; i < texts.length ; i++) {
+				idx[i] = i;
+			}
 			
-			String[] values = CQPSearchEngine.getCqiClient().struc2Str(col.getQualifiedName(), positions);
+			for (int icol = 0 ; icol < pColumns.size() ; icol++) {
+				StructuralUnitProperty col = pColumns.get(icol);
+
+				String[] values = CQPSearchEngine.getCqiClient().struc2Str(col.getQualifiedName(), idx); // idx
+
+				for (int i = 0 ; i < texts.length ; i++) {
+					result.get(texts[i]).add( values[i]);
+				}
+			}
 			
-			for (int i = 0 ; i < texts.length ; i++) {
-				result.get(texts[i]).add( values[i]);
+		} else {
+			int[] positions = getCorpus().getTextStartLimits();
+			
+			for (int icol = 0 ; icol < pColumns.size() ; icol++) {
+				StructuralUnitProperty col = pColumns.get(icol);
+
+				int[] idx = CQPSearchEngine.getCqiClient().cpos2Struc(col.getQualifiedName(), positions);
+				String[] values = CQPSearchEngine.getCqiClient().struc2Str(col.getQualifiedName(), idx);
+
+				for (int i = 0 ; i < texts.length ; i++) {
+					result.get(texts[i]).add( values[i]);
+				}
 			}
 		}
 		
+		
+
 		if (negativeFilters.length() > 0 && pColumns.size() > 0) {
-			
+
 			ArrayList<String> columnNames = new ArrayList<>(pColumns.size());
 			for (StructuralUnitProperty p : pColumns) columnNames.add(p.getName());
-			
+
 			String[] filters = negativeFilters.split(";");
-			
+
 			ArrayList<String> keys = new ArrayList<>(result.keySet());
 			for (String text : keys) {
-				
+
 				for (String negativeFilter : filters) {
 					String[] split = negativeFilter.split("=", 2);
 					if (split.length == 2 
@@ -195,37 +218,37 @@
 				}
 			}
 		}
-		
+
 		return true;
 	}
-	
+
 	@Override
 	protected boolean _toTxt(File outfile, String encoding, String colseparator, String txtseparator) throws Exception {
-		
+
 		PrintWriter writer = org.txm.utils.io.IOUtils.getWriter(outfile, encoding);
-		
+
 		writer.println("text"+colseparator+StringUtils.join(pColumns, colseparator));
-		
+
 		for (String text : result.keySet()) {
 			writer.println(text+colseparator+StringUtils.join(result.get(text), colseparator));
 		}
-		
+
 		writer.close();
 		return false;
 	}
-	
+
 	@Override
 	public String getResultType() {
 		return "TextView";
 	}
-	
+
 	public LinkedHashMap<String, ArrayList<String>> getLines() {
 		return result;
 	}
-	
+
 	public List<StructuralUnitProperty> getColumns() {
-		
+
 		return pColumns;
 	}
-	
+
 }

Index: TXM/trunk/org.txm.rcp.about.fragment/src/org/eclipse/ui/internal/about/InstallationDialog.java
===================================================================
--- TXM/trunk/org.txm.rcp.about.fragment/src/org/eclipse/ui/internal/about/InstallationDialog.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp.about.fragment/src/org/eclipse/ui/internal/about/InstallationDialog.java	(revision 3628)
@@ -60,7 +60,7 @@
 	class ButtonManager {
 
 		private Composite composite;
-		HashMap buttonMap = new HashMap(); // page id->Collection of page
+		HashMap<String, List<Button>> buttonMap = new HashMap<>(); // page id->Collection of page
 
 		// buttons
 
@@ -73,12 +73,14 @@
 		}
 
 		public void update(String currentPageId) {
-			if (composite == null || composite.isDisposed())
+			
+			if (composite == null || composite.isDisposed()) {
 				return;
+			}
 			GC metricsGC = new GC(composite);
 			FontMetrics metrics = metricsGC.getFontMetrics();
 			metricsGC.dispose();
-			List buttons = (List) buttonMap.get(currentPageId);
+			List<?> buttons = (List<?>) buttonMap.get(currentPageId);
 			Control[] children = composite.getChildren();
 
 			int visibleChildren = 0;
@@ -93,6 +95,7 @@
 					setButtonLayoutData(metrics, control, false);
 				}
 			}
+			
 			if (buttons != null) {
 				for (int i = 0; i < buttons.size(); i++) {
 					Button button = (Button) buttons.get(i);
@@ -121,16 +124,16 @@
 		}
 
 		public void addPageButton(String id, Button button) {
-			List list = (List) buttonMap.get(id);
+			List<Button> list = (List<Button>) buttonMap.get(id);
 			if (list == null) {
-				list = new ArrayList(1);
+				list = new ArrayList<>(1);
 				buttonMap.put(id, list);
 			}
 			list.add(button);
 		}
 
 		public void clear() {
-			buttonMap = new HashMap();
+			buttonMap = new HashMap<>();
 		}
 	}
 
@@ -143,7 +146,7 @@
 	private TabFolder folder;
 	IServiceLocator serviceLocator;
 	private ButtonManager buttonManager;
-	private Map pageToId = new HashMap();
+	private Map<InstallationPage, String> pageToId = new HashMap<>();
 	private Dialog modalParent;
 
 	/**
@@ -167,10 +170,10 @@
 		super.configureShell(newShell);
 		String productName = ""; //$NON-NLS-1$
 		IProduct product = Platform.getProduct();
-		if (product != null && product.getName() != null)
+		if (product != null && product.getName() != null) {
 			productName = product.getName();
-		newShell.setText(NLS.bind(
-				WorkbenchMessages.InstallationDialog_ShellTitle, productName));
+		}
+		newShell.setText(NLS.bind(WorkbenchMessages.InstallationDialog_ShellTitle, productName));
 	}
 
 	/*
@@ -223,19 +226,15 @@
 		for (int i = 0; i < elements.length; i++) {
 			IConfigurationElement element = elements[i];
 			TabItem item = new TabItem(folder, SWT.NONE);
-			item.setText(element
-					.getAttribute(IWorkbenchRegistryConstants.ATT_NAME));
+			item.setText(element.getAttribute(IWorkbenchRegistryConstants.ATT_NAME));
 			item.setData(element);
-			item.setData(ID, element
-					.getAttribute(IWorkbenchRegistryConstants.ATT_ID));
+			item.setData(ID, element.getAttribute(IWorkbenchRegistryConstants.ATT_ID));
 
 			Composite control = new Composite(folder, SWT.NONE);
 			control.setLayout(new GridLayout());
 			item.setControl(control);
 		}
 
-
-
 	}
 
 	protected Control createContents(Composite parent) {
@@ -244,16 +243,18 @@
 		if (folder.getItemCount() > 0) {
 			if (lastSelectedTabId != null) {
 				TabItem[] items = folder.getItems();
-				for (int i = 0; i < items.length; i++)
+				for (int i = 0; i < items.length; i++) {
 					if (items[i].getData(ID).equals(lastSelectedTabId)) {
 						folder.setSelection(i);
 						tabSelected(items[i]);
 						selected = true;
 						break;
 					}
+				}
 			}
-			if (!selected)
+			if (!selected) {
 				tabSelected(folder.getItem(0));
+			}
 		}
 		// need to reapply the dialog font now that we've created new
 		// tab items
@@ -275,13 +276,11 @@
 	 */
 	private void tabSelected(TabItem item) {
 		if (item.getData() instanceof IConfigurationElement) {
-			final IConfigurationElement element = (IConfigurationElement) item
-					.getData();
+			final IConfigurationElement element = (IConfigurationElement) item.getData();
 
 			Composite pageComposite = (Composite) item.getControl();
 			try {
-				final InstallationPage page = (InstallationPage) element
-						.createExecutableExtension(IWorkbenchRegistryConstants.ATT_CLASS);
+				final InstallationPage page = (InstallationPage) element.createExecutableExtension(IWorkbenchRegistryConstants.ATT_CLASS);
 				page.createControl(pageComposite);
 				// new controls created since the dialog font was applied, so
 				// apply again.
@@ -290,8 +289,7 @@
 				// Must be done before creating the buttons because the control
 				// button creation methods
 				// use this map.
-				pageToId.put(page, element
-						.getAttribute(IWorkbenchRegistryConstants.ATT_ID));
+				pageToId.put(page, element.getAttribute(IWorkbenchRegistryConstants.ATT_ID));
 				createButtons(page);
 				item.setData(page);
 				item.addDisposeListener(new DisposeListener() {
@@ -312,8 +310,7 @@
 		String id = (String) item.getData(ID);
 		rememberSelectedTab(id);
 		buttonManager.update(id);
-		Button button = createButton(buttonManager.getParent(),
-				IDialogConstants.CLOSE_ID, IDialogConstants.CLOSE_LABEL, true);
+		Button button = createButton(buttonManager.getParent(), IDialogConstants.CLOSE_ID, IDialogConstants.CLOSE_LABEL, true);
 		GridData gd = (GridData) button.getLayoutData();
 		gd.horizontalAlignment = SWT.BEGINNING;
 		gd.horizontalIndent = convertHorizontalDLUsToPixels(IDialogConstants.BUTTON_WIDTH) / 2;
Index: TXM/trunk/org.txm.rcp.about.fragment/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.rcp.about.fragment/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.rcp.about.fragment/META-INF/MANIFEST.MF	(revision 3628)
@@ -5,7 +5,7 @@
 Bundle-Version: 1.0.0.qualifier
 Fragment-Host: org.eclipse.ui.workbench;bundle-version="3.110.1.v20170704-1208"
 Eclipse-PatchFragment: true
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-ClassPath: library.jar,
  .
 Export-Package: org.eclipse.ui.internal.about

Index: TXM/trunk/org.txm.textsbalance.rcp/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.textsbalance.rcp/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.textsbalance.rcp/META-INF/MANIFEST.MF	(revision 3628)
@@ -9,7 +9,7 @@
  ility:=reexport,org.txm.chartsengine.rcp;bundle-version="1.0.0";visib
  ility:=reexport
 Bundle-ManifestVersion: 2
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: Textometrie.org
 Automatic-Module-Name: org.txm.textsbalance.rcp
 

Index: TXM/trunk/org.txm.utils/src/org/txm/utils/processbuilder/ProcessBuilder.java
===================================================================
--- TXM/trunk/org.txm.utils/src/org/txm/utils/processbuilder/ProcessBuilder.java	(revision 0)
+++ TXM/trunk/org.txm.utils/src/org/txm/utils/processbuilder/ProcessBuilder.java	(revision 3628)
@@ -0,0 +1,70 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2013-05-06 17:38:43 +0200 (lun., 06 mai 2013) $
+// $LastChangedRevision: 2386 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.utils.processbuilder;
+
+import java.io.File;
+
+import org.txm.utils.ProcessBuilderBuilder;
+
+import groovy.lang.GroovyClassLoader;
+
+/**
+ * creates a wrapper of a program.
+ *
+ * @param definitionFile the definition file
+ * @param classFile the class file
+ * @param binariesDirectory the binaries directory
+ * @return the object
+ * @author H
+ */
+public class ProcessBuilder {
+	public static Object wrapProgram(File definitionFile, File classFile, File binariesDirectory) {
+		try {
+			ProcessBuilderBuilder.build(definitionFile, classFile);
+			// Application app = new Application(definitionFile);
+			// app.build(classFile);
+		} catch (Exception e) {
+			System.err.println(e);
+			return null;
+		}
+
+		GroovyClassLoader gcl = new GroovyClassLoader();
+		Object aProgram;
+
+		try {
+			gcl.addClasspath("."); //$NON-NLS-1$
+			Class clazz = gcl.parseClass(classFile);
+			aProgram = clazz.getConstructor(String.class).newInstance(binariesDirectory.getAbsolutePath()); // path to the directory containing binaries //$NON-NLS-1$
+
+		} catch (Exception e) {
+			System.err.println(e);
+			return null;
+		}
+		return aProgram;
+	}
+}

Index: TXM/trunk/org.txm.utils/src/org/txm/utils/Pair.java
===================================================================
--- TXM/trunk/org.txm.utils/src/org/txm/utils/Pair.java	(revision 3627)
+++ TXM/trunk/org.txm.utils/src/org/txm/utils/Pair.java	(revision 3628)
@@ -121,7 +121,7 @@
 	public boolean equals(Object obj) {
 		if (!(obj instanceof Pair))
 			return false;
-		Pair p = (Pair) obj;
+		Pair<?,?> p = (Pair<?,?>) obj;
 		return same(p.o1, this.o1) && same(p.o2, this.o2);
 	}
 
